--- old/usr/src/uts/common/io/mac/mac.c	2014-02-20 18:59:05.683526536 +0000
+++ new/usr/src/uts/common/io/mac/mac.c	2014-02-20 18:59:05.697266205 +0000
@@ -2989,6 +2989,8 @@
 	case MAC_PROP_WL_MLME:
 		minsize = sizeof (wl_mlme_t);
 		break;
+	case MAC_PROP_MACADDRESS:
+		minsize = sizeof (mac_addrprop_t);
 	}
 
 	return (valsize >= minsize);
@@ -3065,6 +3067,16 @@
 		break;
 	}
 
+	case MAC_PROP_MACADDRESS: {
+		mac_addrprop_t	*addrprop = val;
+
+		if (addrprop->ma_len != mip->mi_type->mt_addr_length)
+			return (EINVAL);
+
+		err = mac_unicast_primary_set(mh, addrprop->ma_addr);
+		break;
+	}
+
 	default:
 		/* For other driver properties, call driver's callback */
 		if (mip->mi_callbacks->mc_callbacks & MC_SETPROP) {
@@ -3180,6 +3192,16 @@
 		 */
 		return (0);
 
+	case MAC_PROP_MACADDRESS: {
+		mac_addrprop_t	*addrprop = val;
+
+		if (valsize < sizeof (mac_addrprop_t))
+			return (EINVAL);
+		mac_unicast_primary_get(mh, addrprop->ma_addr);
+		addrprop->ma_len = mip->mi_type->mt_addr_length;
+		return (0);
+	}
+
 	default:
 		break;
 
@@ -3333,6 +3355,19 @@
 		if (perm != NULL)
 			*perm = MAC_PROP_PERM_READ;
 		return (0);
+
+	case MAC_PROP_MACADDRESS: {
+		mac_addrprop_t	*defaddr = default_val;
+
+		if (defaddr != NULL) {
+			if (default_size < sizeof (mac_addrprop_t))
+				return (EINVAL);
+			bcopy(mip->mi_info.mi_unicst_addr, defaddr->ma_addr,
+			    mip->mi_type->mt_addr_length);
+			defaddr->ma_len = mip->mi_type->mt_addr_length;
+		}
+		return (0);
+	}
 	}
 
 	/*
